<?php

include_once(realpath(dirname(__FILE__)) . "/../../../classes/PluginsClassiques.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Variable.class.php");
include_once(realpath(dirname(__FILE__)) . "/Comparateur.class.php");

class Shopbotexportservice extends PluginsClassiques {

    public $nom;
    public $ref;
    public $cnx;
    public $comparateurs = array();

    /**
     * Table comparateur principale
     * @var string
     */
    public static $tableComparateur = "shopbotexportservice";

    /**
     * Table contenant les informations des comparateurs
     * @var string
     */
    public static $tableInfos = "shopbotexportservice_infos";

    /**
     * Table contenant les produits des comparateurs associés
     * @var string
     */
    public static $tableCompProduit = "shopbotexportservice_produit";

    /**
     * Table contenant les informations complémentaires des produits
     * @var string
     */
    public static $tableCompComplements = "shopbotexportservice_complements";

    public function __construct() {
        parent::__construct();
        $this->cnx = StaticConnection::getHandle();
        $this->comparateurs = $this->getComparateurs();
        if (isset($_POST["action"]) && $_POST["action"] == "export_csv") {
            $this->_exportCSV();
        }
    }

    private function _exportCSV() {
        header('Content-Type: text/csv');
        header('Content-Disposition: attachment;filename=export_ses.csv');
        $fp = fopen('php://output', 'w');

        if (isset($_POST["date_debut"]) && isset($_POST["date_fin"])) {
            $commandes = $this->_getCommandes($_POST["date_debut"], $_POST["date_fin"]);

            if (count($commandes) > 0) {
                //Titres
                if (isset($_POST["ref"]) && $_POST["ref"] == 1) {
                    $line["ref"] = "Référence commande";
                }
                if (isset($_POST["date_commande"]) && $_POST["date_commande"] == 1) {
                    $line["date_commande"] = "Date commande";
                }
                if (isset($_POST["date_premier_clic"]) && $_POST["date_premier_clic"] == 1) {
                    $line["date_premier_clic"] = "Date premier clic";
                }
                if (isset($_POST["dernier_referent"]) && $_POST["dernier_referent"] == 1) {
                    $line["dernier_referent"] = "Dernier référent avant commande";
                }
                if (isset($_POST["montant"]) && $_POST["montant"] == 1) {
                    $line["montant"] = "Montant commande";
                }
                if (isset($_POST["satut"]) && $_POST["satut"] == 1) {
                    $line["statut"] = " Statut commande";
                }
                fputcsv($fp, $line);
                //Données
                foreach ($commandes as $commande) {
                    $line = array();
                    $datas = $this->getDetailsCmd($commande->ref);

                    if (isset($_POST["ref"]) && $_POST["ref"] == 1) {
                        $line["ref"] = $commande->ref;
                    }
                    if (isset($_POST["date_commande"]) && $_POST["date_commande"] == 1) {
                        $line["date_commande"] = $commande->date;
                    }
                    if (isset($_POST["date_premier_clic"]) && $_POST["date_premier_clic"] == 1) {
                        if ($datas != "Aucune donnée trouvée") {
                            $line["date_premier_clic"] = $this->getDatePremierClic($commande->ref);
                        } else {
                            $line["date_premier_clic"] = "Aucune donnée";
                        }
                    }
                    if (isset($_POST["dernier_referent"]) && $_POST["dernier_referent"] == 1) {
                        if ($datas != "Aucune donnée trouvée") {
                            $i = 1;
                            foreach ($datas as $referer => $urls) {
                                if ($i == count($datas)) {
                                    $line["dernier_referent"] = $referer;
                                }
                                $i++;
                            }
                            if($line["dernier_referent"]==""){
                                $line["dernier_referent"] = "Aucun référent";
                            }
                        } else {
                            $line["dernier_referent"] = "Aucune donnée";
                        }
                    }
                    if (isset($_POST["montant"]) && $_POST["montant"] == 1) {
                        $line["montant"] = ($commande->total() == "") ? "0.00" : $commande->total();
                    }
                    if (isset($_POST["satut"]) && $_POST["satut"] == 1) {
                        $statutdesc = new Statutdesc();
                        $statutdesc->charger($commande->statut);
                        $line["statut"] = $statutdesc->titre;
                    }
                    fputcsv($fp, $line);
                }
            } else {
                
            }
        }
        fclose($fp);
        die;
    }

    private function _getCommandes($debut, $fin) {
        $commandes = array();
        $sql = "SELECT DISTINCT(cmd.id)"
                . " FROM " . Commande::TABLE . " as cmd"
                . " WHERE DATE(date) >= DATE('" . mysql_real_escape_string($debut) . "')"
                . " AND DATE(date) <= DATE('" . mysql_real_escape_string($fin) . "')"
                . " ORDER BY date ASC";
        $result = mysql_query($sql, $this->cnx);
        if ($result && mysql_num_rows($result) > 0) {
            while ($row = mysql_fetch_object($result)) {
                $commandes[] = new Commande($row->id);
            }
        }
        return $commandes;
    }

    /**
     * Activation du plugin
     */
    public function init() {
        $query = "CREATE TABLE IF NOT EXISTS `" . self::$tableComparateur . "`
                 (idComp INT(11) auto_increment,
                  nom VARCHAR(100) NOT NULL,
                  url_image varchar(150),
                  etat bool,
                  PRIMARY KEY (idComp));";
        mysql_query($query, $this->cnx);

        $query = "CREATE TABLE IF NOT EXISTS `" . self::$tableCompProduit . "` (
                  `idComp` int(11) NOT NULL DEFAULT '0',
                  `refProd` varchar(255) NOT NULL DEFAULT '',
                  `categorie` varchar(255) DEFAULT NULL,
                  `old_categorie` varchar(255) DEFAULT NULL,
                  `nb_clics` int(11) DEFAULT '0',
                  `nb_ventes_lien` int(11) DEFAULT '0',
                  `nb_ventes_produit` int(11) DEFAULT '0',
                  `ca` float DEFAULT '0',
                  PRIMARY KEY (`idComp`,`refProd`))";
        mysql_query($query, $this->cnx);
        $query = "CREATE TABLE IF NOT EXISTS `" . self::$tableInfos . "` (
                  `id` int(11) NOT NULL AUTO_INCREMENT,
                  `idCmd` varchar(512) NOT NULL,
                  `data` text DEFAULT NULL,
                  PRIMARY KEY (`id`)
                )";
        mysql_query($query, $this->cnx);

        $query = "CREATE TABLE IF NOT EXISTS `" . self::$tableCompComplements . "`
                    ( `refProd` varchar(255) NOT NULL ,
                    `fabricant` varchar(512) ,
                    `ref-fabricant` varchar(512) ,
                    `ean-cup` varchar(512) ,
                    `isbn` varchar(512) ,
                    `visuel` varchar(512) ,
                  PRIMARY KEY (`refProd`));";
        mysql_query($query, $this->cnx);
    }

    /**
     * Initialise et donne les comparateurs déjà présent dans l'arborescence du plugin
     * @return array
     */
    private function getComparateurs() {
        $comps = array();
        $dir = realpath(dirname(__FILE__)) . "/comparateurs/";
        $handle = opendir($dir);
        while ($files = readdir($handle)) {
            if (is_dir($dir . "/" . $files) && $files != ".." && $files != "." && file_exists($dir . $files . "/" . ucfirst($files) . ".class.php")) {
                array_push($comps, Comparateur::getInstance($files));
            }
        }
        closedir($handle);
        return $comps;
    }

    /**
     * Méthode ajoutant les infos complémentaires d'un produit
     * @param Produit $produit
     */
    public function modprod($produit) {
        if (isset($_POST["fabricant"]) && isset($_POST["ref-fabricant"]) && isset($_POST["ean-cup"]) && isset($_POST["isbn"]) && isset($_POST["visuel"])) {

            $query = "SELECT * FROM " . self::$tableCompComplements . " WHERE refProd = '" . mysql_real_escape_string($produit->ref) . "'";
            $result = mysql_query($query, $this->cnx);
            if ($result && mysql_num_rows($result) == 0) {
                $query = "INSERT INTO " . self::$tableCompComplements . "
                          VALUES ('" . mysql_real_escape_string($produit->ref) . "',
                                  '" . mysql_real_escape_string(trim($_POST["fabricant"])) . "',
                                  '" . mysql_real_escape_string(trim($_POST["ref-fabricant"])) . "',
                                  '" . mysql_real_escape_string(trim($_POST["ean-cup"])) . "',
                                  '" . mysql_real_escape_string(trim($_POST["isbn"])) . "',
                                  '" . mysql_real_escape_string(trim($_POST["visuel"])) . "');";
                try {
                    $this->query($query);
                } catch (Exception $e) {
                    
                }
            } else {
                $query = "UPDATE " . self::$tableCompComplements . "
                          SET `fabricant` = '" . mysql_real_escape_string(trim($_POST["fabricant"])) . "',
                              `ref-fabricant` = '" . mysql_real_escape_string(trim($_POST["ref-fabricant"])) . "',
                              `ean-cup` = '" . mysql_real_escape_string(trim($_POST["ean-cup"])) . "',
                              `isbn` = '" . mysql_real_escape_string(trim($_POST["isbn"])) . "',
                              `visuel` = '" . mysql_real_escape_string(trim($_POST["visuel"])) . "'
                          WHERE refProd = '" . mysql_real_escape_string($produit->ref) . "';";
                try {
                    $this->query($query);
                } catch (Exception $e) {
                    
                }
            }
        }
    }

    /**
     * Méthode executée à chaque affichage de la page (création d'un cookie, incrémentation des compteurs, etc.)
     */
    public function demarrage() {

        global $fond;

        $variable = new Variable();
        $variable->charger("urlsite");


        $request = array("utm_source" => "", "utm_medium" => "", "utm_content" => "", "utm_campaign");
        $url = parse_url("http://" . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']);

        $params = explode("&", $url["query"]);
        foreach ($params as $param) {
            $args = explode("=", $param);
            $request[$args[0]] = $args[1];
        }

        //Cas où référent est comparateur
        if (isset($request["utm_source"]) && isset($request["utm_content"]) && class_exists($request["utm_source"])) {
            $comparateur = Comparateur::getInstance($request["utm_source"]);

            $this->referal($request["utm_source"]);

            $query = "UPDATE " . self::$tableCompProduit . " cp, " . self::$tableComparateur . " c
                      SET nb_clics = " . ($this->getNombreClics() + 1) . "
                      WHERE cp.idComp = c.idComp
                      AND c.nom = '" . mysql_real_escape_string(addslashes($request["utm_source"])) . "'
                      AND cp.refProd = '" . mysql_real_escape_string(addslashes($request["utm_content"])) . "'";
            mysql_query($query, $this->cnx);
        }

        $parse_referer = parse_url($_SERVER["HTTP_REFERER"]);
        $host_referer = $parse_referer["host"];
        $parse_url = parse_url($variable->valeur);
        $host_url = $parse_url["host"];
        //Cas référent divers et pas le site lui même
        if ($host_referer != $host_url) {
            $this->referal($_SERVER["HTTP_REFERER"]);
        }
    }

    public function aprescommande($commande) {
        if (isset($_COOKIE["shopbot_export_service"])) {
            $query = "INSERT INTO " . Shopbotexportservice::$tableInfos . " VALUES ('', '" . $commande->ref . "', '" . mysql_real_escape_string($_COOKIE["shopbot_export_service"]) . "');";
            mysql_query($query, $this->cnx);
            setcookie("shopbot_export_service");
        }
    }

    /**
     * Initialise le cookie listant les referals, incrémente les referals
     * @global string $fond : type de page
     * @param string $referer : le référent
     * @return array : les données sérialisées dans le cookie
     */
    private function referal($referer) {
        global $fond;
        $data = array();
        //Création du cookie tracking
        if (!isset($_COOKIE["shopbot_export_service"])) {
            $data[$referer] = array(array(date("Y-m-d H:i"), $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'], $fond));
            //Cookie créé, valable 30 jours
            setcookie("shopbot_export_service", urlencode(serialize($data)), time() + (30 * 24 * 3600));
        }
        //Cookie déjà existant
        else {
            $data = unserialize(urldecode($_COOKIE["shopbot_export_service"]));
            $exist = false;
            foreach ($data as $key => $value) {
                //Cas où referer existe déjà dans cookie
                if ($referer == $key) {
                    if ($this->testTimeUrl($data, $key, $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'])) {
                        //Mise à jour entrée
                        array_push($data[$key], array(date("Y-m-d H:i", time()), $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'], $fond));
                    }
                    $exist = true;
                    break;
                }
            }
            //Cas où referer existe pas
            if (!$exist) {
                $data[$referer] = array(array(date("Y-m-d H:i"), $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'], $fond));
            }
            setcookie("shopbot_export_service", urlencode(serialize($data)), time() + (30 * 24 * 3600));
        }
        return $data;
    }

    /**
     * Test si l'enregistrement de l'url n'a pas déjà été effectué dans la dernière minute
     * @param array $data
     * @param string $key
     * @return boolean
     */
    private function testTimeUrl($data, $key, $url) {
        foreach ($data[$key] as $i => $value) {
            if (str_replace("//", "", $url) == str_replace("//", "", $data[$key][$i][1]) && $this->diff_date2Time(date("Y-m-d H:i"), $value[0]) < 1) {
                return false;
            }
        }
        return true;
    }

    //Transforme date en timestamp
    private function diff_date2Time($date1, $date2) {
        return (strtotime($date1) - strtotime($date2)) / 60.00;
    }

    /**
     * Suppression du plugin
     */
    public function destroy() {
        /**
          $query = "DROP TABLE " . self::$tableComparateur . ";";
          mysql_query($query, $this->cnx);
          $query = "DROP TABLE " . self::$tableCompProduit . ";";
          mysql_query($query, $this->cnx);
          $query = "DROP TABLE " . self::$tableInfos . ";";
          mysql_query($query, $this->cnx);
          $query = "DROP TABLE " . self::$tableCompComplements . ";";
          mysql_query($query, $this->cnx);
         * */
    }

    /**
     * Recherche des informations pour un produit donné
     * @param <string> $recherche : la recherche voulu
     * @param <int> $idcomparateur : l'id du comparateur
     * @return <string[id][nom]>  : les informations (xml)
     */
    public function rechercher($recherche, $idcomparateur) {

        $tab = array();
        $i = 0;

        if ($idcomparateur != "") {
            $query = "SELECT p.ref, pd.titre, cp.categorie, c.nom, cp.nb_clics, cp.nb_ventes_produit, cp.nb_ventes_lien, cp.ca
                      FROM " . self::$tableComparateur . " c, " . self::$tableCompProduit . " cp, produit p, produitdesc pd
                      WHERE cp.refProd = p.ref
                      AND p.id = pd.produit
                      AND cp.idComp = c.idComp
                      AND (cp.idComp = '$idcomparateur' OR c.nom LIKE '$idcomparateur')
                      AND (pd.chapo LIKE '%$recherche%' OR p.ref LIKE '%$recherche%' OR cp.categorie LIKE '%$recherche%')
                      ORDER BY cp.nb_clics DESC;";
        } else {
            $query = "SELECT p.ref, pd.titre, cp.categorie, c.nom, cp.nb_clics, cp.nb_ventes_produit, cp.nb_ventes_lien, cp.ca
                      FROM " . self::$tableComparateur . " c, " . self::$tableCompProduit . " cp, produit p, produitdesc pd
                      WHERE c.idComp = cp.idComp
                      AND cp.refProd = p.ref
                      AND p.id = pd.produit
                      AND (pd.chapo LIKE '%$recherche%' OR p.ref LIKE '%$recherche%' OR cp.categorie LIKE '%$recherche%' OR c.nom LIKE '%$recherche%')
                      ORDER BY cp.nb_clics DESC;";
        }
        $ret = mysql_query($query, $this->cnx);
        if ($ret && mysql_num_rows($ret) > 0) {
            while ($row = mysql_fetch_object($ret)) {
                $tab[$i]["ref"] = $row->ref;
                $tab[$i]["titre"] = $row->titre;
                $tab[$i]["categorie"] = $row->categorie;
                $tab[$i]["comparateur"] = $row->nom;
                $tab[$i]["clics"] = $row->nb_clics;
                $tab[$i]["ventes_produit"] = $row->nb_ventes_produit;
                $tab[$i]["ventes_lien"] = $row->nb_ventes_lien;
                $tab[$i]["ca"] = $row->ca;
                $i++;
            }
        }
        return $tab;
    }

    /**
     * Obtenir le nombre de produit pour un comparateur (ou tous pour $id = 'all')
     * @param <int> $id : l'id du comparateur
     * @return <int> : le nombre de produits pour le comparateur
     */
    public function getNombreProduit($id) {
        if ($id != "all") {
            $query = "SELECT COUNT(*) as nb FROM " . self::$tableCompProduit . " WHERE idComp = $id AND categorie != ''";
        } else {
            $query = "SELECT COUNT(*) as nb FROM " . self::$tableCompProduit . " WHERE categorie != ''";
        }
        $ret = mysql_query($query, $this->cnx);
        if ($ret && mysql_num_rows($ret) > 0 && $row = mysql_fetch_object($ret)) {
            return $row->nb;
        }
        return 0;
    }

    /**
     * Méthode permettant de réduire la chaîne de caractère par le milieu
     * @param string $str : la chaîne à réduire.
     * @param int $maxlength : la taille maximale
     * @return string : la chaîne réduite
     */
    public function reductionStrMilieu($str, $maxlength) {
        if (strlen($str) > $maxlength) {
            $str1 = substr($str, 0, $maxlength / 2);
            $str2 = substr($str, strlen($str) - $maxlength / 2, $maxlength / 2 + 1);
            $str = $str1 . "..." . $str2;
        }
        return $str;
    }

    /**
     * Donne les compléments d'informations d'un produit
     * @param string $ref : la référence du produit concerné
     * @return object : null si rien trouvé, l'objet du résultat auquel cas.
     */
    public function getComplementsProduit($ref) {
        $query = "SELECT * FROM " . self::$tableCompComplements . " WHERE refProd = '" . $ref . "'";
        $result = mysql_query($query, $this->cnx);
        if ($result && mysql_num_rows($result) > 0) {
            return mysql_fetch_assoc($result);
        }
        return array("fabricant" => "", "ref-fabricant" => "", "ean-cup" => "", "isbn" => "", "visuel" => "");
    }

    /**
     * Obtenir le premier clic effectué par les clients pour un produit
     * @param <string> $ref : la référence du produit
     * @return <int> : le nombre trouvé
     */
    public function getDatePremierClic($ref) {
        $query = "SELECT data
                  FROM " . Shopbotexportservice::$tableInfos . "
                  WHERE idCmd = '" . $ref . "'";
        $ret = mysql_query($query, $this->cnx);
        if ($ret && mysql_num_rows($ret) > 0 && $row = mysql_fetch_object($ret)) {
            $data = @unserialize(urldecode($row->data));
            if (is_array($data) && count($data) > 0) {
                $min = "2100-01-01 00:00";
                foreach ($data as $referer => $urls) {

                    foreach ($urls as $indice => $details) {
                        if (strtotime($details[0]) < strtotime($min)) {
                            $min = $details[0];
                        }
                    }
                }
                return $min;
            }
            return "Aucune date trouvée";
        }
        return "Aucune date trouvée";
    }

    /**
     * Obtenir le nombre de clics effectué avant le passage de la commande
     * @param <string> $ref : la référence du produit
     * @return <int> : le nombre de clic total
     */
    public function getNombreClics() {

        $query = "SELECT nb_clics
                  FROM " . Shopbotexportservice::$tableCompProduit . "
                  WHERE idComp = '" . $this->idComparateur . "'";
        $ret = mysql_query($query, $this->cnx);
        if ($ret && mysql_num_rows($ret) > 0 && $row = mysql_fetch_object($ret)) {
            if ($row->nb_clics != "") {
                return $row->nb_clics;
            }
            return 0;
        }
        return 0;
    }

    public function getDetailsCmd($ref) {
        $query = "SELECT data
                  FROM " . Shopbotexportservice::$tableInfos . "
                  WHERE idCmd = '" . $ref . "'";
        $ret = mysql_query($query, $this->cnx);
        if ($ret && mysql_num_rows($ret) > 0 && $row = mysql_fetch_object($ret)) {
            $data = @unserialize(urldecode($row->data));
            return $data;
        }
        return "Aucune donnée trouvée";
    }
}

?>