jQuery.fn.extend({
    on: function(types, selector, data, fn, /*INTERNAL*/ one) {
        var origFn, type;

        // Types can be a map of types/handlers
        if (typeof types === "object") {
            // ( types-Object, selector, data )
            if (typeof selector !== "string") { // && selector != null
                // ( types-Object, data )
                data = data || selector;
                selector = undefined;
            }
            for (type in types) {
                this.on(type, selector, data, types[ type ], one);
            }
            return this;
        }

        if (data == null && fn == null) {
            // ( types, fn )
            fn = selector;
            data = selector = undefined;
        } else if (fn == null) {
            if (typeof selector === "string") {
                // ( types, selector, fn )
                fn = data;
                data = undefined;
            } else {
                // ( types, data, fn )
                fn = data;
                data = selector;
                selector = undefined;
            }
        }
        if (fn === false) {
            fn = returnFalse;
        } else if (!fn) {
            return this;
        }

        if (one === 1) {
            origFn = fn;
            fn = function(event) {
                // Can use an empty set, since event contains the info
                jQuery().off(event);
                return origFn.apply(this, arguments);
            };
            // Use same guid so caller can remove using origFn
            fn.guid = origFn.guid || (origFn.guid = jQuery.guid++);
        }
        return this.each(function() {
            jQuery.event.add(this, types, fn, data, selector);
        });
    }
});

$(document).ready(function() {
    $("div[id^=dialog-]").each(function() {
        $(this).dialog({modal: true, width: 500, autoOpen: false});
    });
    $(".question-dialog").click(function() {
        var type = $(this).children("img").first().attr("title");
        $("#dialog-" + type).dialog("open");
        return false;
    });
    $("a[id^=conf-]").click(function() {
        var nom = $(this).attr("id").split("-")[1];
        $("#nom-comparateur").attr("value", nom);
        $("#dialog-conf").dialog("open");
        $.ajax({url: httphost + "/ajax/shopbots_categorie.php?comparateur=" + nom, success: function(data) {
                data = "<option value=''>----- Désactiver -----</option>" + data;
                $("#categorie-comp").html(data);
            }});
        return false;
    });
    $(".ui-dialog-titlebar-close").click(function() {
        $("#categorie-comp").html("<option value=''>Patientez...</option>");
        $("#nom-comparateur").attr("value", "");
    });
    $("a[id^=etat-]").click(function() {
        var comp = $(this).attr("id").split("-")[1];
        var img = $(this).children("img");
        var etat = $(this).children("img").attr("alt");
        $.ajax({url: httphost + "/ajax/shopbots_change.php?ref=" + $("input[name=ref]").val() + "&active=" + etat + "&comparateur=" + comp, success: function(data) {
                if (etat == "on") {
                    img.attr("src", httphost + "/images/off_comp.png");
                    img.attr("alt", "off");
                } else {
                    if (data != "" && data != "Aucune catégorie associée.") {
                        img.attr("src", httphost + "/images/on_comp.png");
                        img.attr("alt", "on");
                    } else {
                        alert("Associez d'abord une catégorie du comparateur au produit en cours.")
                    }
                }
            }});
        return false;
    });
    $("#submit-cat").live("click", function() {
        $.ajax({url: httphost + "/ajax/shopbots_comparateurproduit.php?comparateur=" + encodeURIComponent($("#nom-comparateur").val()) + "&ref=" + encodeURIComponent($("input[name=ref]").val()) + "&categorie=" + encodeURIComponent($("#categorie-comp option:selected").val()), success: function(data) {
                $("#cat-" + $("#nom-comparateur").val()).html(data);
                $("#etat-" + $("#nom-comparateur").val()).children("img").attr("src", httphost + "/images/on_comp.png");
                $("#etat-" + $("#nom-comparateur").val()).children("img").attr("alt", "on");
                $("#dialog-conf").dialog("close");
            }});
        return false;
    });
});